# graphql-binding

[![CircleCI](https://circleci.com/gh/graphql-binding/graphql-binding.svg?style=shield)](https://circleci.com/gh/graphql-binding/graphql-binding) [![npm version](https://badge.fury.io/js/graphql-binding.svg)](https://badge.fury.io/js/graphql-binding)

## Overview

🔗 GraphQL bindings are **modular building blocks** that allow to embed existing GraphQL APIs into your own GraphQL server. Think about it as turning (parts of) GraphQL APIs into reusable LEGO building blocks. Bindings may be generated in JavaScript, TypeScript, or Flow. 

> The idea of GraphQL bindings is introduced in detail in this blog post: [Reusing & Composing GraphQL APIs with GraphQL Bindings](https://www.prisma.io/blog/reusing-and-composing-graphql-apis-with-graphql-bindings-80a4aa37cff5/)

## Install

```sh
yarn add graphql-binding
```

## [Docs :books:](https://oss.prisma.io/content/GraphQL-Binding/01-Overview.html)
Check out the docs on [oss.prisma.io](https://oss.prisma.io/content/GraphQL-Binding/01-Overview.html).

## Public GraphQL bindings

You can find practical, production-ready examples here:

* [`graphql-binding-github`](https://github.com/graphcool/graphql-binding-github)
* [`prisma-binding`](https://github.com/graphcool/prisma-binding)

> Note: If you've created your own GraphQL binding based on this package, please add it to this list via a PR 🙌

If you have any questions, share some ideas or just want to chat about GraphQL bindings, join the [`#graphql-bindings`](https://graphcool.slack.com/messages/graphql-bindings) channel in our [Slack](https://slack.graph.cool/).

