"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_1 = require("graphql");
var Delegate_1 = require("./Delegate");
// to avoid recreation on each instantiation for the same schema, we cache the created methods
var delegateCache = new Map();
var ormCache = new Map();
var Binding = /** @class */ (function (_super) {
    __extends(Binding, _super);
    function Binding(_a) {
        var schema = _a.schema, fragmentReplacements = _a.fragmentReplacements, before = _a.before;
        var _this = _super.call(this, { schema: schema, fragmentReplacements: fragmentReplacements, before: before }) || this;
        _this.currentInstructions = [];
        _this.processInstructions = function () { return __awaiter(_this, void 0, void 0, function () {
            var _a, ast, variables, variableDefinitions, restAst, document, result, pointer;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.generateSelections(this.currentInstructions), ast = _a.ast, variables = _a.variables;
                        variableDefinitions = ast.variableDefinitions, restAst = __rest(ast, ["variableDefinitions"]);
                        document = {
                            kind: graphql_1.Kind.DOCUMENT,
                            definitions: [
                                {
                                    kind: graphql_1.Kind.OPERATION_DEFINITION,
                                    operation: 'query',
                                    directives: [],
                                    variableDefinitions: variableDefinitions,
                                    selectionSet: {
                                        kind: graphql_1.Kind.SELECTION_SET,
                                        selections: [restAst],
                                    },
                                },
                            ],
                        };
                        this.before();
                        return [4 /*yield*/, graphql_1.execute(this.schema, document, {}, {}, variables)];
                    case 1:
                        result = _b.sent();
                        pointer = result;
                        while (pointer && typeof pointer === 'object' && !Array.isArray(pointer)) {
                            pointer = pointer[Object.keys(pointer)[0]];
                        }
                        return [2 /*return*/, pointer];
                }
            });
        }); };
        _this.then = function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var result, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.processInstructions()];
                    case 1:
                        result = _a.sent();
                        resolve(result);
                        return [3 /*break*/, 3];
                    case 2:
                        e_1 = _a.sent();
                        reject(e_1);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        }); };
        _this.catch = function (reject) { return __awaiter(_this, void 0, void 0, function () {
            var e_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.processInstructions()];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        e_2 = _a.sent();
                        reject(e_2);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        }); };
        _this.buildMethods();
        _this.subscription = _this.buildSubscriptionMethods();
        return _this;
    }
    Binding.prototype.buildQueryMethods = function (operation) {
        var _this = this;
        var queryType = operation === 'query'
            ? this.schema.getQueryType()
            : this.schema.getMutationType();
        if (!queryType) {
            return {};
        }
        var fields = queryType.getFields();
        return Object.entries(fields)
            .map(function (_a) {
            var fieldName = _a[0], field = _a[1];
            return {
                key: fieldName,
                value: function (args, info, options) {
                    return _this.delegate(operation, fieldName, args, info, options);
                },
            };
        })
            .reduce(function (acc, curr) {
            return (__assign({}, acc, (_a = {}, _a[curr.key] = curr.value, _a)));
            var _a;
        }, {});
    };
    Binding.prototype.buildSubscriptionMethods = function () {
        var _this = this;
        var subscriptionType = this.schema.getSubscriptionType();
        if (!subscriptionType) {
            return {};
        }
        var fields = subscriptionType.getFields();
        return Object.entries(fields)
            .map(function (_a) {
            var fieldName = _a[0], field = _a[1];
            return {
                key: fieldName,
                value: function (args, info, options) {
                    return _this.delegateSubscription(fieldName, args, info, options);
                },
            };
        })
            .reduce(function (acc, curr) {
            return (__assign({}, acc, (_a = {}, _a[curr.key] = curr.value, _a)));
            var _a;
        }, {});
    };
    Binding.prototype.generateSelections = function (instructions) {
        var _this = this;
        var variableDefinitions = [];
        var variables = {};
        var variableCounter = {};
        var ast = instructions.reduceRight(function (acc, instruction, index) {
            var args = [];
            if (instruction.args && Object.keys(instruction.args).length > 0) {
                Object.entries(instruction.args).forEach(function (_a) {
                    var name = _a[0], value = _a[1];
                    var variableName;
                    if (typeof variableCounter[name] === 'undefined') {
                        variableName = name;
                        variableCounter[name] = 0;
                    }
                    else {
                        variableCounter[name]++;
                        variableName = name + "_" + variableCounter[name];
                    }
                    variables[variableName] = value;
                    var inputArg = instruction.field.args.find(function (arg) { return arg.name === name; });
                    if (!inputArg) {
                        throw new Error("Could not find argument " + name + " for type " + _this.getTypeName(instruction.field.type));
                    }
                    variableDefinitions.push({
                        kind: graphql_1.Kind.VARIABLE_DEFINITION,
                        variable: {
                            kind: graphql_1.Kind.VARIABLE,
                            name: {
                                kind: graphql_1.Kind.NAME,
                                value: variableName,
                            },
                        },
                        type: inputArg.astNode.type,
                    });
                    args.push({
                        kind: graphql_1.Kind.ARGUMENT,
                        name: {
                            kind: graphql_1.Kind.NAME,
                            value: name,
                        },
                        value: {
                            kind: graphql_1.Kind.VARIABLE,
                            name: {
                                kind: 'Name',
                                value: variableName,
                            },
                        },
                    });
                });
            }
            var node = {
                kind: graphql_1.Kind.FIELD,
                name: {
                    kind: graphql_1.Kind.NAME,
                    value: instruction.fieldName,
                },
                arguments: args,
                directives: [],
                selectionSet: {
                    kind: graphql_1.Kind.SELECTION_SET,
                    selections: [],
                },
            };
            var type = _this.getDeepType(instruction.field.type);
            if (index === instructions.length - 1 &&
                type instanceof graphql_1.GraphQLObjectType) {
                node.selectionSet.selections = Object.entries(type.getFields())
                    .filter(function (_a) {
                    var _ = _a[0], field = _a[1];
                    var fieldType = _this.getDeepType(field.type);
                    return fieldType instanceof graphql_1.GraphQLScalarType;
                })
                    .map(function (_a) {
                    var fieldName = _a[0];
                    return ({
                        kind: graphql_1.Kind.FIELD,
                        name: {
                            kind: graphql_1.Kind.NAME,
                            value: fieldName,
                        },
                        arguments: [],
                        directives: [],
                    });
                });
            }
            if (acc) {
                node.selectionSet.selections.push(acc);
            }
            return node;
        }, null);
        return {
            ast: __assign({}, ast, { variableDefinitions: variableDefinitions }),
            variables: variables,
        };
    };
    Binding.prototype.buildMethods = function () {
        this.buildDelegateMethods();
        this.buildORMMethods();
    };
    Binding.prototype.buildDelegateMethods = function () {
        var methods = this.getDelegateMethods();
        Object.assign(this.delegate, methods);
    };
    Binding.prototype.getDelegateMethods = function () {
        var cachedMethods = delegateCache.get(this.schema);
        if (cachedMethods) {
            return cachedMethods;
        }
        var methods = {
            query: this.buildQueryMethods('query'),
            mutation: this.buildQueryMethods('mutation'),
            subscription: this.buildSubscriptionMethods(),
        };
        delegateCache.set(this.schema, methods);
        return methods;
    };
    Binding.prototype.buildORMMethods = function () {
        this.types = this.getORMTypes();
        this.query = this.types.Query;
        this.mutation = this.types.Mutation;
    };
    Binding.prototype.getORMTypes = function () {
        var _this = this;
        var cachedTypes = ormCache.get(this.schema);
        if (cachedTypes) {
            return cachedTypes;
        }
        var typeMap = this.schema.getTypeMap();
        var types = Object.entries(typeMap)
            .map(function (_a) {
            var name = _a[0], type = _a[1];
            var value = (_b = {
                    then: _this.then,
                    catch: _this.catch
                },
                _b[Symbol.toStringTag] = 'Promise',
                _b);
            if (type instanceof graphql_1.GraphQLObjectType) {
                value = __assign({}, value, Object.entries(type.getFields())
                    .map(function (_a) {
                    var fieldName = _a[0], field = _a[1];
                    return {
                        key: fieldName,
                        value: function (args) {
                            _this.currentInstructions.push({
                                fieldName: fieldName,
                                args: args,
                                field: field,
                            });
                            var typeName = _this.getTypeName(field.type);
                            return _this.types[typeName];
                        },
                    };
                })
                    .reduce(reduceKeyValue, {}));
            }
            return {
                key: name,
                value: value,
            };
            var _b;
        })
            .reduce(reduceKeyValue, {});
        ormCache.set(this.schema, types);
        return types;
    };
    Binding.prototype.getTypeName = function (type) {
        if (type.ofType) {
            return this.getDeepType(type.ofType);
        }
        return type.name;
    };
    Binding.prototype.getDeepType = function (type) {
        if (type.ofType) {
            return this.getDeepType(type.ofType);
        }
        return type;
    };
    return Binding;
}(Delegate_1.Delegate));
exports.Binding = Binding;
var reduceKeyValue = function (acc, curr) {
    return (__assign({}, acc, (_a = {}, _a[curr.key] = curr.value, _a)));
    var _a;
};
//# sourceMappingURL=Binding.js.map